<template>
<div>
    <br/>
    <h3>Technologic Card number: :</h3>
    <div v-for="card in technologic_card_list" :key="card.id">
      <a :href="card.pdf_card" >{{card.number}}</a>
      <button v-if="$store.state.user?.is_superuser" @click="EditTechnologicCard(card.id)">Edit</button>
      <button v-if="$store.state.user?.is_superuser" @click="DeleteTechnologicCard(card.id)">Delete</button>
    </div>
  </div>
</template>

<script>
import { setAuthorizationToken } from "../../utils/authUtils";
import { getTechnologicCards, deleteDataBaseObject } from "../../utils/apiUtils";
import router from "../../router";

const technologic_cards_url = "http://127.0.0.1:8000/handlings/technologic_card/";

export default {
  name: "TechnologicCardBrowse",
  props: {
    after_edit : Function
  },
  data: function() {
    return {
      technologic_card_list: []
    };
  },
  methods: {
    EditTechnologicCard(id) {
      this.after_edit?.(id);
    },
    DeleteTechnologicCard(id) {
      if (window.confirm("Are you sure ?")) {
        (async () => {
          try {
              setAuthorizationToken(localStorage.getItem("jwtAccessToken"));
              const response = await deleteDataBaseObject(technologic_cards_url + id + "/");
              if (response.status === 204) {
                  window.alert("technologic_card deleted");
                  this.technologic_card_list = await getTechnologicCards();
              }
          } catch (error) {
              window.alert("cannot delete this technologic card");
          }
      })();
      }
    }
  },
  computed: {
    isAuthenticated: function() {
      return this.$store.state.isAuthenticated
    }
  },
  mounted: function() {
    (async () => {
        setAuthorizationToken(localStorage.getItem("jwtAccessToken"));
        this.technologic_card_list = await getTechnologicCards();
    })();
  }
};
</script>

<style scoped>
/* @TODO do something with this styles!!! - make it global or something */
</style>>